SystemOrganization addCategory: #'O-Core-Misc'!

Interval subclass: #OstInterval
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstInterval class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:32'!
initialize
	OstObject omnifyClass: self.! !

!OstInterval class methodsFor: 'instance creation' stamp: 'StefanMarr 6/6/2013 17:24'!
new
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	<omniReplacement: #omniBasicNew>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	OutOfMemory signal.
	^ self basicNew  "retry if user proceeds"! !

!OstInterval methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
species
	^ OstArray! !

Rectangle subclass: #OstRectangle
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstRectangle class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 18:16'!
initialize
	OstObject omnifyClass: self! !

!OstRectangle methodsFor: 'rectangle functions' stamp: 'StefanMarr 5/30/2013 16:46'!
intersect: aRectangle 
	"Answer a Rectangle that is the area in which the receiver overlaps with 
	aRectangle. Optimized for speed; old code read:
		^Rectangle 
			origin: (origin max: aRectangle origin)
			corner: (corner min: aRectangle corner)
	"
	| aPoint left right top bottom |
	aPoint := aRectangle origin.
	aPoint x > origin x 
		ifTrue: [ left := aPoint x ]
		ifFalse: [ left := origin x ].
	aPoint y > origin y 
		ifTrue: [ top := aPoint y ]
		ifFalse: [ top := origin y ].
	aPoint := aRectangle corner.
	aPoint x < corner x 
		ifTrue: [ right := aPoint x ]
		ifFalse: [ right := corner x ].
	aPoint y < corner y 
		ifTrue: [ bottom := aPoint y ]
		ifFalse: [ bottom := corner y ].
	^ OstRectangle 
		origin: (OstPoint x: left y: top)
		corner: (OstPoint x: right y: bottom)! !

Monitor subclass: #OstMonitor
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstMonitor class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 21:45'!
initialize
	OstObject omnifyClass: self! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:46'!
defaultQueue
	defaultQueue ifNil: [defaultQueue := OstOrderedCollection new].
	^ defaultQueue! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
queueDict
	^ queueDict ifNil: [queueDict := OstIdentityDictionary new].! !

Association subclass: #OstAssociation
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstAssociation class methodsFor: 'class initialization' stamp: 'StefanMarr 4/30/2013 13:23'!
initialize
	OstObject omnifyClass: self.! !

TestCase subclass: #OstTestCase
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstTestCase commentStamp: 'StefanMarr 6/6/2013 13:35' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstTestCase class methodsFor: 'initialize - event' stamp: 'StefanMarr 7/21/2012 16:53'!
initialize
	OstObject omnifyClass: OstTestCase! !

!OstTestCase methodsFor: 'asserting' stamp: 'StefanMarr 6/6/2013 11:13'!
assert: expectedA or: expectedB equals: actual
	| isEqual |
	isEqual := (expectedA = actual) or: [expectedB = actual].
	^ self
		assert: isEqual
		description: [
			String streamContents: [:stream | 
				stream
					nextPutAll: 'Expected ';
					nextPutAll: (expectedA printStringLimitedTo: 10);
					nextPutAll: ' or ';
					nextPutAll: (expectedB printStringLimitedTo: 10);
					nextPutAll: ' but was ';
					nextPutAll: (actual printStringLimitedTo: 10);
					nextPutAll: '.']]! !

Dictionary subclass: #OstDictionary
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:49'!
arrayType
	^ OstArray! !

!OstDictionary class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 23:29'!
initialize
	OstObject omnifyClass: self! !

!OstDictionary methodsFor: 'accessing' stamp: 'StefanMarr 5/30/2013 16:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (OstAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

IdentityDictionary subclass: #OstIdentityDictionary
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstIdentityDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:50'!
arrayType
	^ OstArray! !

!OstIdentityDictionary class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 23:36'!
initialize
	OstObject omnifyClass: self.! !

SortedCollection subclass: #OstSortedCollection
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:44'!
arrayType
	^ OstArray! !

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 13:14'!
initialize
	OstObject omnifyClass: self! !

Point subclass: #OstPoint
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstPoint class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 19:26'!
initialize
	OstObject omnifyClass: self.! !

Array variableSubclass: #OstArray
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstArray commentStamp: 'StefanMarr 6/6/2013 13:33' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 5/31/2013 00:29'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!OstArray class methodsFor: 'private' stamp: 'StefanMarr 1/10/2012 13:26'!
initialize
	OstObject omnifyClass: OstArray! !

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 7/22/2012 00:03'!
new: size
	<omniUnenforced>
	| arr |
	arr := super new: size.
	OstDomain initializeDomainForNewObject: arr of: self.
	^ arr! !

OrderedCollection subclass: #OstOrderedCollection
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstOrderedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:51'!
arrayType
	^ OstArray! !

!OstOrderedCollection class methodsFor: 'class initialization' stamp: 'StefanMarr 4/28/2013 22:24'!
initialize
	OstObject omnifyClass: self! !

SharedQueue subclass: #OstSharedQueue
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSharedQueue class methodsFor: 'class initialization' stamp: 'StefanMarr 4/29/2013 17:03'!
initialize
	OstObject omnifyClass: self! !

!OstSharedQueue methodsFor: 'initializing' stamp: 'StefanMarr 5/30/2013 16:45'!
initialize
	monitor := OstMonitor new.
	items   := OstOrderedCollection new.! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value terminatedWithError'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 5/13/2013 17:59'!
await
	<omniUnenforced>
	| i |
	i := 0.
	[value = NoValueDelivered and: [terminatedWithError = nil]] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		signal waitTimeoutMSecs: 100.
		i := i + 1.
		i > 300 ifTrue: [Halt now.].
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/18/2012 21:57'!
deliver: aValue
	<omniUnenforced>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 1/23/2013 13:32'!
failed: anError
	terminatedWithError := anError! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 1/23/2013 13:33'!
read
	<omniUnenforced>
	self await.
	terminatedWithError = nil ifTrue: [
		^ value ].
	
	"On failure, raise the exception again in the current context."
	terminatedWithError signal! !

Object subclass: #OstObject
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 6/6/2013 13:34' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstObject class methodsFor: 'omnify' stamp: 'StefanMarr 6/10/2013 17:49'!
omnifyClass: aClass
	"First add all inst vars"
	self instVarNames do: [:varName | 
		(aClass hasInstVarNamed: varName) ifFalse: [
			aClass addInstVarNamed: varName]].
	
	"Then copy the methods"
	#('*O-ST-Isolate-Core' '*O-ST-NoOpt-Core'
	  '*O-ST-Core') do: [:methCategory | 
		(self organization listAtCategoryNamed: methCategory) do: [:selector |
			| method |
			method := self lookupSelector: selector.
			aClass compile: method getSourceFromFile
		       classified: methCategory
		       withStamp: method timeStamp
		       notifying: nil
		       logSource: true.
	]].! !

Set subclass: #OstSet
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSet class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:46'!
arrayType
	^ OstArray! !

!OstSet class methodsFor: 'private' stamp: 'StefanMarr 4/30/2013 17:46'!
initialize
	OstObject omnifyClass: self.! !

!OstSet methodsFor: 'converting' stamp: 'StefanMarr 5/30/2013 16:45'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| arr index |
	arr := OstArray new: self size.
	index := 0.
	self do: [:each | arr at: (index := index + 1) put: each].
	^ arr! !
OstSet initialize!
OstRectangle initialize!
OstOrderedCollection initialize!
OstTestCase initialize!
OstPoint initialize!
OstAssociation initialize!
OstIdentityDictionary initialize!
OstInterval initialize!
OstSharedQueue initialize!
OPromise initialize!
OstArray initialize!
OstDictionary initialize!
OstSortedCollection initialize!
OstMonitor initialize!
